#ifndef __EMITTED_VALIDATE_H
#define __EMITTED_VALIDATE_H

#include <bits/stdc++.h>

typedef void (*feedback_function)(const char*, ...);

const int EXITCODE_AC = 0;
const int EXITCODE_WA = 0;

// declare a constant to be used as user_out.
const std::string FILENAME_USER_OUTPUT = "user_out";
// declare a constant to be used as input.
const std::string FILENAME_INPUT = "input";

#define USAGE "./%s\n"
// we have to define USAGE as dummy because we don't want to modify the lib. too much.

std::ifstream judge_in, judge_ans;
// another ifstream must be used for user_out;
std::ifstream user_out;

char *feedbackdir = NULL;

void vreport_feedback(const char* msg, va_list pvar) {
    assert(stderr);
    vfprintf(stderr, msg, pvar);
}

void report_feedback(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
}

void judge_message(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
}

void judge_error(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
    assert(0);
}

// cleaning up.
void cleanup() {
    fflush(stderr);
    fclose(stderr);
    fflush(stdout);
    fclose(stdout);
    judge_in.close();
    user_out.close();
}

// write another function ``scoring()`` for ac or wa.
void scoring(double score) {
    fprintf(stdout, "%.f", score + 1e-9);
}

void accept() {
    scoring(100.);
    cleanup();
    exit(EXITCODE_AC);
}

void accept_with_score(double scorevalue) {
    scoring(scorevalue);
    cleanup();
    exit(EXITCODE_AC);
}

void wrong_answer(const char* msg, ...) {
    va_list pvar;
    va_start(pvar, msg);
    vreport_feedback(msg, pvar);
    scoring(0.);
    cleanup();
    exit(EXITCODE_WA);
}

void init_io() {
    judge_in.open(FILENAME_INPUT, std::ios_base::in);
    if(judge_in.fail()) {
        judge_error("failed to open input file.\n");
    }
    user_out.open(FILENAME_USER_OUTPUT, std::ios_base::in);
    if(user_out.fail()) {
        judge_error("failed to open user output file.\n");
    }
    judge_ans.open("answer", std::ios_base::in);
    if(judge_ans.fail()) {
        judge_error("failed to open answer file.\n");
    }
}
using namespace std;
#define nmax 50
bool a[nmax][nmax];
int m, n, r, c, preX = -1, preY, x, y;

bool check(int x, int y) {
    if (x < 1 || x > n || y < 1 || y > m) return 0;
    if (preX == -1) {
        if (x != c || y != r)
            return 0;
        preX = x; preY = y;
        a[y][x] = 1;
        return 1;
    }
    if (abs(x - preX) + abs(y - preY) != 3 || a[y][x]) return 0;
    a[y][x] = 1;
    preX = x; preY = y;
    return 1;
}
bool check(istream &inf, istream &ans, istream &ouf, feedback_function waf) {
    int da, cnt = 0;
    ans >> da;
    if (da == -1) {
        if (!(ouf >> x))
            waf("Sai. Du lieu ra khong dung dinh dang.\n");
        if (x != -1)
            waf("Sai. Khong co duong di thoa man.\n");
        string s;
        if (ouf >> s)
            waf("Sai. Du lieu ra khong dung dinh dang.\n");

        judge_message("OK. Khong co duong di thoa man!\n");
        return 1;
    }
    inf >> m >> n >> r >> c;
    memset(a, 0, sizeof a);
    while (ouf >> y >> x) {
        if (!check(x, y))
            waf("Sai. Duong di khong dung.\n");
        cnt++;
    }
    if (cnt != m * n)
        waf("Sai. Duong di khong qua het cac o.\n");

    judge_message("OK. Duong di dung!\n", a);
        return 1;
}
#endif

int main(void) {
    init_io();
    check(judge_in, judge_ans, user_out, wrong_answer);
    accept();
}
